﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Persistence.Services;
using Telerik.Windows.Controls;
using Telerik.Windows.Persistence;
using Telerik.Windows.Persistence.Storage;

namespace PersistingGridViewInStream
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : RadWindow
    {
        private IsolatedStorageProvider isoProvider;
        public MainWindow()
        {
            InitializeComponent();

            this.Loaded +=new RoutedEventHandler(MainWindow_Loaded);
            this.PreviewClosed+=new EventHandler<WindowPreviewClosedEventArgs>(MainWindow_PreviewClosed);
           // isoProvider = new IsolatedStorageProvider();
            // register the custom property provider for the RadGridView:
          //  ServiceProvider.RegisterPersistenceProvider<ICustomPropertyProvider>(typeof(RadGridView), new GridViewCustomPropertyProvider());
            this.DataContext = ExamplesDB.GetCustomers();

        }

        void MainWindow_PreviewClosed(object sender, WindowPreviewClosedEventArgs e)
        {
            PersistenceManager.SetStorageId(this, "RadWindow2");
            Persist(PersistenceAction.Save);
            this.ClearValue(PersistenceManager.StorageIdProperty);
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            WindowState = WindowState.Maximized;
            PersistenceManager.SetStorageId(this, "RadWindow2");
            Persist(PersistenceAction.Load);
            this.ClearValue(PersistenceManager.StorageIdProperty);
        }
        private void Persist(PersistenceAction pPersistenceAction)
        {
            ServiceProvider.RegisterPersistenceProvider<ICustomPropertyProvider>(typeof(RadGridView), new GridViewCustomPropertyProvider());

            PersistenceManager manager = new PersistenceManager();
            IsolatedStorageProvider storage = new IsolatedStorageProvider(manager);
           // storage.DeleteIsolatedStorageFiles();

            try
            {
                try
                {
                    if (pPersistenceAction == PersistenceAction.Load)
                    {
                        storage.LoadFromStorage(); // TODO CHECK
                    }
                    else if (pPersistenceAction == PersistenceAction.Save)
                    {
                        storage.SaveToStorage(); // TODO CHECK
                    }
                }
                catch (Exception ex)
                {
                }
            }
            finally
            {
                ServiceProvider.UnregisterPersistenceProvider<ICustomPropertyProvider>(typeof(RadGridView));
            }
        }

        public enum PersistenceAction { Load, Save }
    }
}
